org.apache.jmeter.gui

## Interface JMeterGUIComponent

- All Superinterfaces:
    ClearGui
  All Known Implementing Classes:
    AbstractAssertionGui, AbstractConfigGui, AbstractControllerGui, AbstractJMeterGuiComponent, AbstractListenerGui, AbstractPostProcessorGui, AbstractPreProcessorGui, AbstractRandomTimerGui, AbstractSamplerGui, AbstractScopedJMeterGuiComponent, AbstractThreadGroupGui, AbstractTimerGui, AbstractVisualizer, AjpSamplerGui, AnchorModifierGui, ArgumentsPanel, AssertionGui, AssertionVisualizer, AuthPanel, BackendListenerGui, BeanShellAssertionGui, BeanShellSamplerGui, BoundaryExtractorGui, CacheManagerGui, ComparisonVisualizer, ConstantTimerGui, CookiePanel, CounterConfigGui, CriticalSectionControllerGui, DNSCachePanel, DurationAssertionGui, ExampleSamplerGui, ForeachControlPanel, FtpConfigGui, FtpTestSamplerGui, GaussianRandomTimerGui, GraphVisualizer, HeaderPanel, HTMLAssertionGui, HtmlExtractorGui, HTTPArgumentsPanel, HttpDefaultsGui, HttpMirrorControlGui, HttpTestSampleGui, IfControllerPanel, IncludeControllerGui, InterleaveControlGui, JavaConfigGui, JavaTestSamplerGui, JMSPublisherGui, JMSSamplerGui, JMSSubscriberGui, JSONPathAssertionGui, JSONPostProcessorGui, JUnitTestSamplerGui, LDAPArgumentsPanel, LdapConfigGui, LdapExtConfigGui, LdapExtTestSamplerGui, LdapTestSamplerGui, LogicControllerGui, LoginConfigGui, LoopControlPanel, MailerVisualizer, MailReaderSamplerGui, MD5HexAssertionGUI, ModuleControllerGui, NamePanel, ObsoleteGui, OnceOnlyControllerGui, PoissonRandomTimerGui, PostThreadGroupGui, PropertyControlGui, ProxyControlGui, RandomControlGui, RandomOrderControllerGui, RecordController, RegexExtractorGui, RegExUserParametersGui, RespTimeGraphVisualizer, ResultActionGui, ResultSaverGui, RunTimeGui, SampleTimeoutGui, SetupThreadGroupGui, SimpleConfigGui, SimpleDataWriter, SizeAssertionGui, SMIMEAssertionGui, SmtpSamplerGui, StatGraphVisualizer, StatVisualizer, SummariserGui, SummaryReport, SwitchControllerGui, SystemSamplerGui, TableVisualizer, TCPConfigGui, TCPSamplerGui, TestActionGui, TestBeanGUI, TestFragmentControllerGui, TestPlanGui, ThreadGroupGui, ThroughputControllerGui, TransactionControllerGui, UniformRandomTimerGui, URLRewritingModifierGui, UserParametersGui, ViewResultsFullVisualizer, WhileControllerGui, WorkBenchGui, XMLAssertionGui, XMLSchemaAssertionGUI, XPath2ExtractorGui, XPathAssertionGui, XPathExtractorGui

      public interface JMeterGUIComponent
      extends ClearGui

  Implementing this interface indicates that the class is a JMeter GUI Component. A JMeter GUI Component is essentially the GUI display code associated with a JMeter Test Element. The writer of the component must take care to make the component be consistent with the rest of JMeter's GUI look and feel and behavior. Use of the provided abstract classes is highly recommended to make this task easier.
  See Also:
    `AbstractJMeterGuiComponent`, `AbstractConfigGui`, `AbstractAssertionGui`, `AbstractControllerGui`, `AbstractTimerGui`, `AbstractVisualizer`, `AbstractSamplerGui`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default boolean` | `canBeAdded()` Returns whether a component of this type can be added to the test plan.
    `void` | `configure(TestElement element)` The GUI must be able to extract the data from the TestElement and update all GUI fields to represent those data.
    `javax.swing.JPopupMenu` | `createPopupMenu()` When a user right-clicks on the component in the test tree, or selects the edit menu when the component is selected, the component will be asked to return a JPopupMenu that provides all the options available to the user from this component.
    `TestElement` | `createTestElement()` JMeter test components are separated into a model and a GUI representation.
    `java.lang.String` | `getDocAnchor()` Get the component's document anchor name.
    `java.lang.String` | `getLabelResource()` Get the component's resource name, which getStaticLabel uses to derive the component's label in the local language.
    `java.util.Collection<java.lang.String>` | `getMenuCategories()` This is the list of add menu categories this gui component will be available under.
    `java.lang.String` | `getName()` Gets the name of the JMeter GUI component.
    `java.lang.String` | `getStaticLabel()` Get the component's label.
    `boolean` | `isEnabled()` Test GUI elements can be disabled, in which case they do not become part of the test when run.
    `void` | `modifyTestElement(TestElement element)` GUI components are responsible for populating TestElements they create with the data currently held in the GUI components.
    `void` | `setEnabled(boolean enabled)` Set whether this component is enabled.
    `void` | `setName(java.lang.String name)` Sets the name of the JMeter GUI Component.

    - ### Methods inherited from interface org.apache.jmeter.gui.ClearGui

      `clearGui`

- - ### Method Detail

    - #### setName

          void setName(java.lang.String name)

      Sets the name of the JMeter GUI Component. The name of the component is used in the Test Tree as the name of the tree node.
      Parameters:
        `name` - the name of the component

    - #### getName

          java.lang.String getName()

      Gets the name of the JMeter GUI component. The name of the component is used in the Test Tree as the name of the tree node.
      Returns:
        the name of the component

    - #### getStaticLabel

          java.lang.String getStaticLabel()

      Get the component's label. This label is used in drop down lists that give the user the option of choosing one type of component in a list of many. It should therefore be a descriptive name for the end user to see. It must be unique to the class. It is also used by Help to find the appropriate location in the documentation. Normally getLabelResource() should be overridden instead of this method; the definition of this method in AbstractJMeterGuiComponent is intended for general use.
      Returns:
        GUI label for the component.
      See Also:
        `getLabelResource()`

    - #### getLabelResource

          java.lang.String getLabelResource()

      Get the component's resource name, which getStaticLabel uses to derive the component's label in the local language. The resource name is fixed, and does not vary with the selected language. Normally this method should be overridden in preference to overriding getStaticLabel(). However where the resource name is not available or required, getStaticLabel() may be overridden instead.
      Returns:
        the resource name

    - #### getDocAnchor

          java.lang.String getDocAnchor()

      Get the component's document anchor name. Used by Help to find the appropriate location in the documentation
      Returns:
        Document anchor (#ref) for the component.

    - #### createTestElement

          TestElement createTestElement()

      JMeter test components are separated into a model and a GUI representation. The model holds the data and the GUI displays it. The GUI class is responsible for knowing how to create and initialize with data the model class that it knows how to display, and this method is called when new test elements are created.

      The canonical implementation looks like this:

           public TestElement createTestElement() {
               TestElementXYZ el = new TestElementXYZ();
               modifyTestElement(el);
               return el;
           }

      Returns:
        the Test Element object that the GUI component represents.

    - #### modifyTestElement

          void modifyTestElement(TestElement element)

      GUI components are responsible for populating TestElements they create with the data currently held in the GUI components. This method should overwrite whatever data is currently in the TestElement as it is called after a user has filled out the form elements in the gui with new information.

      The canonical implementation looks like this:

           public void modifyTestElement(TestElement element) {
               element.clear(); // many implementations use this
               configureTestElement(element);
               // Using the element setters (preferred):
               TestElementXYZ xyz = (TestElementXYZ) element;
               xyz.setState(guiState.getText());
               xyz.setCode(guiCode.getText());
               ... other GUI fields ...
               // or directly (do not use unless there is no setter for the field):
               element.setProperty(TestElementXYZ.STATE, guiState.getText())
               element.setProperty(TestElementXYZ.CODE, guiCode.getText())
               ... other GUI fields ...
           }

      Parameters:
        `element` - the TestElement to modify

    - #### isEnabled

          boolean isEnabled()

      Test GUI elements can be disabled, in which case they do not become part of the test when run.
      Returns:
        true if the element should be part of the test run, false otherwise

    - #### setEnabled

          void setEnabled(boolean enabled)

      Set whether this component is enabled.
      Parameters:
        `enabled` - true for enabled, false for disabled.

    - #### createPopupMenu

          javax.swing.JPopupMenu createPopupMenu()

      When a user right-clicks on the component in the test tree, or selects the edit menu when the component is selected, the component will be asked to return a JPopupMenu that provides all the options available to the user from this component.
      Returns:
        a JPopupMenu appropriate for the component.

    - #### configure

          void configure(TestElement element)

      The GUI must be able to extract the data from the TestElement and update all GUI fields to represent those data. This method is called to allow JMeter to show the user the GUI that represents the test element's data.

      The canonical implementation looks like this:

           public void configure(TestElement element) {
               super.configure(element);
               // Using the element getter (preferred):
               TestElementXYZ xyz = (TestElementXYZ) element;
               guiState.setText(xyz.getState());
               guiCode.setText(xyz.getCode());
               ... other GUI fields ...
               // or using the element property names directly (do not use unless there is no getter for the field)
               guiState.setText(element.getPropertyAsString(TestElementXYZ.STATE));
               guiCode.setText(element.getPropertyAsString(TestElementXYZ.CODE));
               ... other GUI fields ...
           }

      Parameters:
        `element` - the TestElement to configure

    - #### getMenuCategories

          java.util.Collection<java.lang.String> getMenuCategories()

      This is the list of add menu categories this gui component will be available under. For instance, if this represents a Controller, then the MenuFactory.CONTROLLERS category should be in the returned collection. When a user right-clicks on a tree element and looks through the "add" menu, which category your GUI component shows up in is determined by which categories are returned by this method. Most GUI's belong to only one category, but it is possible for a component to exist in multiple categories.
      Returns:
        a Collection of Strings, where each element is one of the constants defined in MenuFactory
      See Also:
        `MenuFactory`

    - #### canBeAdded

          default boolean canBeAdded()

      Returns whether a component of this type can be added to the test plan.
      Returns:
        true if the component can be added, false otherwise.

Copyright © 1998-2019 Apache Software Foundation. All Rights Reserved.